superacl = {
    init: function(){
        this.ctl = $('superacl_manager');
        if(!this.ctl) return;

        var sel = $('acl__user').getElementsByTagName('select')[0];

        addEvent(sel,'change',superacl.userselhandler);
        addEvent($('acl__tree'),'click',superacl.treehandler);
        addEvent($('acl__user').getElementsByTagName('input')[1],'click',superacl.loadinfo);
        addEvent($('acl__user').getElementsByTagName('input')[1],'keypress',superacl.loadinfo);
        
        addEvent($('acl__filter'),'click',superacl.filterhandler);
    },


    /**
     * Handle user dropdown
     */
    userselhandler: function(e){
        // make entry field visible/invisible
        if(this.value == '__g__' || this.value == '__u__'){
            $('acl__user').getElementsByTagName('input')[0].style.display = ''; //acl_w
            $('acl__user').getElementsByTagName('input')[1].style.display = ''; //submit
        }else{
            $('acl__user').getElementsByTagName('input')[0].style.display = 'none';
            $('acl__user').getElementsByTagName('input')[1].style.display = 'none';
        }

        superacl.loadinfo();
    },

    /**
     * Load the current permission info and edit form
     *
     * @param frm - Form element with needed data
     */
    loadinfo: function(){
        // get form
        var frm = $('acl__detail').getElementsByTagName('form')[0];

        // prepare an AJAX call
        var ajax = new sack(DOKU_BASE + 'lib/plugins/superacl2/ajax.php');
        ajax.AjaxFailedAlert = '';
        ajax.encodeURIString = false;
        if(ajax.failed) return true;

        // prepare data
        var data = Array();
        data[0] = ajax.encVar('ns',frm.elements['ns'].value);
        data[1] = ajax.encVar('id',frm.elements['id'].value);
        data[2] = ajax.encVar('acl_t',frm.elements['acl_t'].value);
        data[3] = ajax.encVar('acl_w',frm.elements['acl_w'].value);
        data[4] = ajax.encVar('ajax','info');

        ajax.elementObj = $('acl__info');

        ajax.runAJAX(data.join('&'));
        return false;
    },

    /**
     * parse URL attributes into a associative array
     *
     * @todo put into global script lib?
     */
    parseatt: function(str){
        if(str[0] == '?') str = str.substr(1);
        var attributes = {};
        var all = str.split('&');
        for(var i=0; i<all.length; i++){
            var att = all[i].split('=');
            attributes[att[0]] = decodeURIComponent(att[1]);
        }
        return attributes;
    },

    /**
     * htmlspecialchars equivalent
     *
     * @todo put in gloabl scripts lib?
     */
    hsc: function(str) {
        str = str.replace(/&/g,"&amp;");
        str = str.replace(/\"/g,"&quot;");
        str = str.replace(/\'/g,"&#039;");
        str = str.replace(/</g,"&lt;");
        str = str.replace(/>/g,"&gt;");
        return str;
    },


    /**
     * Open or close a subtree using AJAX
     *
     * @author Andreas Gohr <andi@splitbrain.org>
     */
    treetoggle: function(clicky){
        var listitem = clicky.parentNode.parentNode;

        // if already open, close by removing the sublist
        var sublists = listitem.getElementsByTagName('ul');
        if(sublists.length){
            listitem.removeChild(sublists[0]);
            clicky.src = DOKU_BASE+'lib/images/plus.gif';
            clicky.alt = '+';
            return false;
        }

        // get the enclosed link (is always the first one)
        var link = listitem.getElementsByTagName('a')[0];

        // prepare an AJAX call to fetch the subtree
        var ajax = new sack(DOKU_BASE + 'lib/plugins/superacl2/ajax.php');
        ajax.AjaxFailedAlert = '';
        ajax.encodeURIString = false;
        if(ajax.failed) return true;

        //prepare the new ul
        var ul = document.createElement('ul');
        listitem.appendChild(ul);
        ajax.elementObj = ul;
        ajax.runAJAX(link.search.substr(1)+'&ajax=tree');
        clicky.src = DOKU_BASE+'lib/images/minus.gif';
        return false;
    },

    /**
     * Handles all clicks in the tree, dispatching the right action based on the
     * clicked element
     */
    treehandler: function(e){
        if(e.target.src){ // is it an image?
            superacl.treetoggle(e.target);
        } else if(e.target.href){ // is it a link?
            // remove highlighting
            var obj = getElementsByClass('cur',$('acl__tree'),'a')[0];
            if(obj) obj.className = obj.className.replace(/ cur/,'');

            // add new highlighting
            e.target.className += ' cur';

            // set new page to detail form
            var frm = $('acl__detail').getElementsByTagName('form')[0];
            if(e.target.className.search(/wikilink1/) > -1){
                frm.elements['ns'].value = '';
                frm.elements['id'].value = superacl.hsc(superacl.parseatt(e.target.search)['id']);
            }else if(e.target.className.search(/idx_dir/) > -1){
                frm.elements['ns'].value = superacl.hsc(superacl.parseatt(e.target.search)['ns']);
                frm.elements['id'].value = '';
            }

            superacl.loadinfo();
	    	if (! $('acl__filter').checked)
	    	  superacl.filter_tablerows();
        }

        e.stopPropagation();
        e.preventDefault();
        return false;
    },
    
    /**
     * Handles clicks on the "filter" checkbox
     */
     
    filterhandler: function(e) {
	    var frm = $('acl__detail').getElementsByTagName('form')[0];
	    
    	if ($('acl__filter').checked) {
    	  superacl.show_all_tablerows();
    	  frm.elements['acl__filter'].value = $('acl__filter').value;
    	} else { 
    	  superacl.filter_tablerows();
    	  frm.elements['acl__filter'].value = "";
    	}
    },
    
    /**
     * Shows all html_table rows
     */
    show_all_tablerows: function() {
      window.setTimeout(function() {
	      var rows = $('acl__htmltable').getElementsByTagName('tr');
	      for ( i = 1; i < rows.length; i++) {
	        rows[i].className = "";
	      }
      },10);
    },
    
    /**
     * Only shows rows matching to the current namespace/page selected
     */
     filter_tablerows: function() {
     	window.setTimeout(function() {
	  
	        var frm = $('acl__detail').getElementsByTagName('form')[0];
	        var ns = frm.elements['ns'].value;
	        if(! ns) {
	          ns = frm.elements['id'].value;
	          ns = ns.substr(0,ns.lastIndexOf(':'));
	        }
	        if (ns =="*")
	          ns = "";
	          
	        var rows = $('acl__htmltable').getElementsByTagName('tr');
	        for ( i = 1; i < rows.length; i++) {
	          var isNs = (rows[i].firstChild.firstChild.className == "aclns");
	          var id = rows[i].firstChild.firstChild.innerHTML;
	          id = id.substr(0,id.lastIndexOf(':'));
	          
	          var show;
	          if (! isNs) { 
	            show = (id == ns);
	          } else {
	            show = (ns.substr(0,id.length) == id);
	          }
	          
	          if (show)
	            rows[i].className = "";
	          else
	            rows[i].className = "hidden";
	        }
	        
	     },10);
        
     }
    

};

addInitEvent(superacl.init);
